# Iso

La configuration présente dans le dossier iso contient une configuration custom
ayant pour but de simplifier l'installation des VM au CR@NS.

## Création de l'iso

Pour configurer l'iso, il suffit d'éditer les fichiers de configuration.

Pour générer l'iso, il suffit d'éxécuter la commande suivante :

```bash
nix build .#nixosConfigurations.cransIso.config.system.build.isoImage
```

Une fois générer, l'iso se trouve dans le dossier `result/iso`. il est alors
possible de le renommer puis de le rendre accessible sur les hyperviseurs avec
au choix :

 - envoyer le fichier depuis l'interface graphique de proxmox
 - en l'envoyant avec la commande
   `scp result/iso/<nom>.iso sam.adm.crans.org:/var/lib/vz/template/iso/`

Remarque : quelque soit la solution choisie, pensez à procéder de la même façon
pour tout les hyperviseurs.

il est également possible de vérifier si l'iso est opérationnel à en procédant
ainsi :

```bash
nix-shell -p qemu
qemu-system-x86_64 -enable-kvm -m 256 -cdrom result/iso/<nom>.iso
```

## Installation d'une VM

Pour l'installation d'une VM, il faut commencer par booter sur l'iso custom.
Une fois cela effectuer, la configuration réseau doit être effectuer.

Un script permettant de simplifier celle ci est disponible à l'aide de la
commande `crans-ip-config`. Il vous est alors demandé un id qui correspond au
numéro de la VM.

Pour simplifier le partitionnement du disque, vous pouvez éxécuter la commande
`crans-disk-config`. Il vous sera alors demander le disque à considérer.

ATTENTION /!\ : la configuration automatique des disques ne permet de faire
uniquement la configuration la plus basique (une seule parition en ext4).
Pour des configurations plus complexe, veuillez voir des
[documentations](../README.md) plus détailler et ne pas utiliser le script.

Récapitulatif des commandes :

```bash
$ sudo su
$ crans-ip-config
id : 42  # a priori, l'id est supérieur à 100
vlan 10, interface enxXX : 18
souhaitez-vous configurer le vlan 3 ? (o/n)O
vlan 3, interface ensXX : 19

$ crans-disk-config
<la liste des disques apparaît>
disque : sda
Veuillez déplacer le fichier /mnt/etc/nixos/hardware-configuration.nix à
l'emplacement de la vm en cours d'installation.
Pensez également à vous mettre sur la branche appropriée
```

À ce niveau là, la connexion ssh sur le nouveau serveur est possible avec le
mot de passe `crans`.
